/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para guardar los datos de los modelos solicitados para Programa.

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha             	Autor                       Descripcion
    1.0    20-Enero-2020    	Héctor Figueroa             Creación
******************************************************************************* */

public without sharing class TAM_SolicitudPrevisualizaPedidoInvCtrl {

	static String sRectorTypePasoPrograma = Schema.SObjectType.TAM_VinesFlotillaPrograma__c.getRecordTypeInfosByName().get('Programa').getRecordTypeId();
	static String sRectorTypePasoGFlotilla = Schema.SObjectType.TAM_VinesFlotillaPrograma__c.getRecordTypeInfosByName().get('Flotilla').getRecordTypeId();

	static String sRectorTypePasoInventario = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Inventario').getRecordTypeId();
	static String sRectorTypePasoPedidoEspecial = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Pedido Especial').getRecordTypeId();

	static String sRectorTypePasoDetSolPrograma = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Programa').getRecordTypeId();
	static String sRectorTypePasoDetSolFlotilla = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Flotilla').getRecordTypeId();

	static String sRectorTypePasoSolPrograma = Schema.SObjectType.TAM_SolicitudesFlotillaPrograma__c.getRecordTypeInfosByName().get('Programa').getRecordTypeId();
	static String sRectorTypePasoSolProgramaCerrada = Schema.SObjectType.TAM_SolicitudesFlotillaPrograma__c.getRecordTypeInfosByName().get('Cerrada Programa').getRecordTypeId();
	
	static String sRectorTypePasoSolVentaCorporativa = Schema.SObjectType.TAM_SolicitudesFlotillaPrograma__c.getRecordTypeInfosByName().get('Venta Corporativa').getRecordTypeId();
	static String sRectorTypePasoSolVentaCorporativaCerrada = Schema.SObjectType.TAM_SolicitudesFlotillaPrograma__c.getRecordTypeInfosByName().get('Cerrada Venta Corporativa').getRecordTypeId();
		    
	//Un constructor por default
	public TAM_SolicitudPrevisualizaPedidoInvCtrl(){}
    
    //Obtener un Set de las series disponibles
    @AuraEnabled
    public static List<TAM_OrdenDeCompraWrapperClass> consultaDatosVines(String recordId) {
    	System.debug('EN consultaDatosVines recordId: ' + recordId);
    	String sMensaejeSalidaUpd = '';  
    	String slObjWrpDist = '';

		String sRectorTypePaso = getTipoRegSol(recordId);
		System.debug('EN saveDatos sRectorTypePaso: ' + sRectorTypePaso );
		
		TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
		List<TAM_OrdenDeCompraWrapperClass> lObjWrpDist = new List<TAM_OrdenDeCompraWrapperClass>();		
		List<TAM_DetalleOrdenCompra__c>	ListDistProgUps = new List<TAM_DetalleOrdenCompra__c>();
		Set<String> setCaveDistr = new Set<String>();
		
		List<TAM_WrpDistSolFlotillaPrograma> lObjWrpDistElim = new List<TAM_WrpDistSolFlotillaPrograma>();
		Set<String> setCaveDistrElim = new Set<String>();
		List<TAM_OrdenDeCompraWrapperClass>	ListDistProgDel = new List<TAM_OrdenDeCompraWrapperClass>();
		//Obten la lista de precios actual
		Map<String, Double> mapPriceBookEntry = ObtenerPrecios();
		Map<String, Map<string, CatalogoCentralizadoModelos__c>> MapIdModIdColDesc = new Map<String, Map<string, CatalogoCentralizadoModelos__c>>();
		Map<String, Set<String>> MapIdExtIdColor = new Map<String, Set<String>>();
		
		//Para los datos del inventario
        Id userId = UserInfo.getUserId();
        user usuario = [SELECT id,CodigoDistribuidor__c FROM user WHERE id =: userId];
        String strCodigoDistribuidor = usuario.CodigoDistribuidor__c == null ? '57000' : usuario.CodigoDistribuidor__c;
        
        if (Test.isRunningTest())
        	strCodigoDistribuidor = '570550';
        	
        Map<String, Set<String>> mapIdExtTotal = new Map<String, Set<String>>();
        Set<String> setIdMod = new Set<String>();
        for (InventarioWholesale__c objInve : [SELECT  Id, TAM_IdExterno__c, Name, TAM_ExteriorColorCode__c,
        	 TAM_InteriorColorCode__c FROM InventarioWholesale__c WHERE Dealer_Code__c =: strCodigoDistribuidor]){
        	 String sIdColExtIdColInt = objInve.TAM_ExteriorColorCode__c + '' + objInve.TAM_InteriorColorCode__c;
             //Metelos al set de  MapIdExtIdColor
             if (MapIdExtIdColor.containsKey(objInve.TAM_IdExterno__c))
             	MapIdExtIdColor.get(objInve.TAM_IdExterno__c).add(sIdColExtIdColInt);
             if (!MapIdExtIdColor.containsKey(objInve.TAM_IdExterno__c))
             	MapIdExtIdColor.put(objInve.TAM_IdExterno__c, new Set<String>{sIdColExtIdColInt});
        }                                                            
		System.debug('EN getDistribuidores getModelos mapIdExtTotal: ' + mapIdExtTotal);

		Set<String> setIdExterno = new Set<String>();
		for(CatalogoCentralizadoModelos__c objModelo : [  SELECT Id, Name, Marca__c,Serie__c,
                                                         Modelo__c,AnioModelo__c,CodigoColorExterior__c,
                                                         CodigoColorInterior__c, DescripcionColorExterior__c,
                                                         DescripcionColorInterior__c,Version__c
                                                         FROM CatalogoCentralizadoModelos__c ORDER BY Name]) {
			String sIdExterno = objModelo.Modelo__c + '' + objModelo.AnioModelo__c;
			setIdExterno.add(sIdExterno);                                                            	
		}
		
       	Map<String, String> mapIdExtProdSerie = new Map<String, String>();
		//Cinsulta el catalogo de prodictos para que te traigas las series reales
		for (Product2 producto :   [Select p.Serie__r.Id_Externo_Serie__c, p.Serie__c, p.IdExternoProducto__c From Product2 p
				where IdExternoProducto__c IN : setIdExterno]){
			//System.debug('EN getDistribuidores getSeries producto.IdExternoProducto__c: ' + producto.IdExternoProducto__c);		
			//Agregalo al mapa de mapIdExtProdSerie
			mapIdExtProdSerie.put(producto.IdExternoProducto__c, producto.Serie__r.Id_Externo_Serie__c);
		}
		System.debug('EN getDistribuidores consultaDatosVines mapIdExtProdSerie: ' + mapIdExtProdSerie.keySet());
		System.debug('EN getDistribuidores consultaDatosVines mapIdExtProdSerie: ' + mapIdExtProdSerie.Values());
		
		Map<String, String> mapIdExtCatCetMod = new Map<String, String>();
		for (CatalogoCentralizadoModelos__c objPaso : [Select c.TAM_ColorExtColorInt__c, c.Modelo__c, c.DescripcionColorInterior__c, 
			  c.DescripcionColorExterior__c, c.CodigoColorInterior__c, c.CodigoColorExterior__c, c.AnioModelo__c, c.Serie__c
              FROM CatalogoCentralizadoModelos__c c
              Where TAM_ColorExtColorInt__c != null
              ORDER BY Name]){
              //Crea la llave externa
              String sIdExt = objPaso.Modelo__c + '' + objPaso.AnioModelo__c;
              String sColorExtColorInt = objPaso.TAM_ColorExtColorInt__c;
              //Ve si ya existe en MapIdModIdColDesc
              if (MapIdModIdColDesc.containsKey(sIdExt))
              	//Ve si existe la combinación de colores TAM_ColorExtColorInt__c
              	MapIdModIdColDesc.get(sIdExt).put(sColorExtColorInt, objPaso);              	
              //Ve si ya existe en MapIdModIdColDesc
              if (!MapIdModIdColDesc.containsKey(sIdExt))
              	MapIdModIdColDesc.put(sIdExt, new Map<string, CatalogoCentralizadoModelos__c>{sColorExtColorInt => objPaso});
              //String sIdExtCatCemMod = objPaso.Serie__c + '' + objPaso.AnioModelo__c + '' + objPaso.Modelo__c + '' + objPaso.TAM_ColorExtColorInt__c;
              String sIdExtCatCemMod = mapIdExtProdSerie.get(sIdExt) + '' + objPaso.AnioModelo__c + '' + objPaso.Modelo__c + '' + objPaso.TAM_ColorExtColorInt__c;              
              mapIdExtCatCetMod.put(sIdExtCatCemMod, objPaso.id);	                       				
		}
		System.debug('EN getDistribuidores getModelos MapIdModIdColDesc: ' + MapIdModIdColDesc);
		System.debug('EN getDistribuidores getModelos mapIdExtCatCetMod: ' + mapIdExtCatCetMod.KeySet());
		System.debug('EN getDistribuidores getModelos mapIdExtCatCetMod: ' + mapIdExtCatCetMod.Values());
		
		//Consulta los datos del detalle de vines
		Integer intCnt = 0;
		//Ya tienes la llave consulta los datos en TAM_VinesFlotillaPrograma__c
		for (TAM_VinesFlotillaPrograma__c objDistrib : [Select ID, Name, TAM_Cliente__r.Codigo_Distribuidor__c,
			TAM_Cliente__r.Name, TAM_IdExterno__c, TAM_DealerDaily__c, TAM_CanceladoPreviamente__c,
			TAM_SolicitudCanceladaPrevia__c, TAM_NoDealerIntercambio__c, TAM_Intercambio__c	
			From TAM_VinesFlotillaPrograma__c Where TAM_SolicitudFlotillaPrograma__c = :recordId 
			And TAM_Intercambio__c = false and TAM_CanceladoPreviamente__c = false
			And TAM_DealerDaily__c = false]){

			//Una variable de paso para el id externo
			String sTAMIdExterno = objDistrib.TAM_IdExterno__c;
			System.debug('EN getDistribuidores getModelos sTAMIdExterno: ' + sTAMIdExterno);
			//Destrulle el TAM_IdExterno__c separandolo por los guienes en un arreglo
			String[] slDatosModelo = sTAMIdExterno.split('-');
			
			//Ve si la longiutud del arreglo es mayor a 0
			if (slDatosModelo.size() > 0){
				
				//a1w3F000001ZCqzQAG-2020-COROLLA HV-1780-LE HV-1F7-20-JTDBBRBEXLJ019654-0123F0000018JKoQAM
				String strCodigoModelo = slDatosModelo[3] + '' + slDatosModelo[1];
				String strIdColor = '';
				if (slDatosModelo.size() == 8)
					strIdColor = slDatosModelo[4] + '' + slDatosModelo[5];
				if (slDatosModelo.size() == 9)
					strIdColor = slDatosModelo[5] + '' + slDatosModelo[6];					
				
				//Buaca el sIdExterno en MapIdModIdColDesc
				Map<string, CatalogoCentralizadoModelos__c> objMapCatCentMod = new Map<string, CatalogoCentralizadoModelos__c>();
				CatalogoCentralizadoModelos__c CatCentMod = new CatalogoCentralizadoModelos__c();
				if (MapIdModIdColDesc.containsKey(strCodigoModelo))
					 objMapCatCentMod = MapIdModIdColDesc.get(strCodigoModelo);
				System.debug('EN getDistribuidores getModelos objMapCatCentMod: ' + objMapCatCentMod);
				
				//Busca la clave de strIdColor en el mapa de  objMapCatCentMod
				if (objMapCatCentMod.containsKey(strIdColor))
					CatCentMod = objMapCatCentMod.get(strIdColor);
				
				System.debug('EN getDistribuidores getModelos slDatosModelo: ' + slDatosModelo + ' size: ' + slDatosModelo.size());		 		
				System.debug('EN getDistribuidores getModelos strCodigoModelo: ' + strCodigoModelo + ' strIdColor: ' + strIdColor );		 	
				System.debug('EN getDistribuidores getModelos CatCentMod: ' + CatCentMod.DescripcionColorExterior__c + ' ' + CatCentMod.DescripcionColorInterior__c);
					
				String sMarca = 'Toyota';
				String sSerie = slDatosModelo[2];
				String sModelo = slDatosModelo[3];
				String sAnioModelo = slDatosModelo[1];
				String sVersion = '';
				String sCodigoColorExterior = slDatosModelo[4] + ' ' + CatCentMod.DescripcionColorExterior__c;
				String sCodigoColorInterior = slDatosModelo[5] + ' ' + CatCentMod.DescripcionColorInterior__c; 
				String sVin = slDatosModelo[6];
					            
	            //Crea el objeto del tipo TAM_OrdenDeCompraWrapperClass
				TAM_OrdenDeCompraWrapperClass objWrpOrdCompPaso = new TAM_OrdenDeCompraWrapperClass(
	            			sMarca,
	                        sSerie,
	                        sModelo,
	                        sAnioModelo,
	                        sVersion,
	                        slDatosModelo[4],
	                        slDatosModelo[5],
	                        CatCentMod.DescripcionColorExterior__c, //Desc color ext
	                        CatCentMod.DescripcionColorInterior__c, //Desc color int
	                        null, //strCantidad
	                        null, //strDescuentoDealer
	                        String.valueOf(mapPriceBookEntry.get(strCodigoModelo)), //strPrecioSinIVA
	                        null, //strSubtotal
	                        sSerie + '-' + sModelo + '-' + sAnioModelo + '-' + sCodigoColorExterior + '-' + sCodigoColorInterior + '-' + sVersion, //strName
	                        sSerie + '-' + sVersion + '-' + sModelo + '-' + sAnioModelo, //strNameCustom
	                        sCodigoColorExterior + '-' + '', //strColorExteriorCustom
	                        sCodigoColorInterior + '-' + '', //strColorInteriorCustom
	                        false //boolDistribuidoraActual
                );
                
                //Inicializa el vin
                objWrpOrdCompPaso.strVin = sVin;
                objWrpOrdCompPaso.strNoDealer = objDistrib.TAM_NoDealerIntercambio__c;
                objWrpOrdCompPaso.blnIntercambio = objDistrib.TAM_Intercambio__c;                
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.blnDd = objDistrib.TAM_DealerDaily__c;
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.blnCancel = objDistrib.TAM_CanceladoPreviamente__c;
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.strSolName = objDistrib.TAM_SolicitudCanceladaPrevia__c;                
                
                String sIdExtCatModCet = slDatosModelo[2] + '' + slDatosModelo[1] + '' + slDatosModelo[3] + '' + slDatosModelo[4] + '' + slDatosModelo[5];
				System.debug('EN getDistribuidores getModelos sIdExtCatModCet: ' + sIdExtCatModCet);
				
                objWrpOrdCompPaso.strIdCatModelos = mapIdExtCatCetMod.containsKey(sIdExtCatModCet) ?  mapIdExtCatCetMod.get(sIdExtCatModCet) : null;
                System.debug('EN getDistribuidores getModelos objWrpOrdCompPaso.strIdCatModelos: ' + objWrpOrdCompPaso.strIdCatModelos);
                
				//Agregalo a la lista 
				lObjWrpDist.add(objWrpOrdCompPaso);
			}//Fin si slDatosModelo.length() > 0			
		}//fin del for para TAM_VinesFlotillaPrograma__c
		System.debug('EN consultaDatosVines lObjWrpDist: ' + lObjWrpDist);	
						  	        
        //serializa la lista y crea el JSON
		slObjWrpDist = JSON.serialize(lObjWrpDist);
        System.debug('EN consultaDatosVines objRespoPaso: ' + slObjWrpDist);
                 
        //Regresa la cadena
        return lObjWrpDist;
    }  

    //Obtener un Set de las series disponibles
    @AuraEnabled
    public static List<TAM_OrdenDeCompraWrapperClass> consultaDatosVinesInterc(String recordId) {
    	System.debug('EN consultaDatosVinesInterc recordId: ' + recordId);
    	String sMensaejeSalidaUpd = '';  
    	String slObjWrpDist = '';

		String sRectorTypePaso = getTipoRegSol(recordId);
		System.debug('EN saveDatos sRectorTypePaso: ' + sRectorTypePaso );
		
		TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
		List<TAM_OrdenDeCompraWrapperClass> lObjWrpDist = new List<TAM_OrdenDeCompraWrapperClass>();		
		List<TAM_DetalleOrdenCompra__c>	ListDistProgUps = new List<TAM_DetalleOrdenCompra__c>();
		Set<String> setCaveDistr = new Set<String>();
		
		List<TAM_WrpDistSolFlotillaPrograma> lObjWrpDistElim = new List<TAM_WrpDistSolFlotillaPrograma>();
		Set<String> setCaveDistrElim = new Set<String>();
		List<TAM_OrdenDeCompraWrapperClass>	ListDistProgDel = new List<TAM_OrdenDeCompraWrapperClass>();
		//Obten la lista de precios actual
		Map<String, Double> mapPriceBookEntry = ObtenerPrecios();
		Map<String, Map<string, CatalogoCentralizadoModelos__c>> MapIdModIdColDesc = new Map<String, Map<string, CatalogoCentralizadoModelos__c>>();
		Map<String, Set<String>> MapIdExtIdColor = new Map<String, Set<String>>();
		
		//Para los datos del inventario
        Id userId = UserInfo.getUserId();
        user usuario = [SELECT id,CodigoDistribuidor__c FROM user WHERE id =: userId];
        String strCodigoDistribuidor = usuario.CodigoDistribuidor__c == null ? '57000' : usuario.CodigoDistribuidor__c;
        
        if (Test.isRunningTest())
        	strCodigoDistribuidor = '570550';
        	
        Map<String, Set<String>> mapIdExtTotal = new Map<String, Set<String>>();
        Set<String> setIdMod = new Set<String>();
        for (InventarioWholesale__c objInve : [SELECT  Id, TAM_IdExterno__c, Name, TAM_ExteriorColorCode__c,
        	 TAM_InteriorColorCode__c FROM InventarioWholesale__c WHERE Dealer_Code__c =: strCodigoDistribuidor]){
        	 String sIdColExtIdColInt = objInve.TAM_ExteriorColorCode__c + '' + objInve.TAM_InteriorColorCode__c;
             //Metelos al set de  MapIdExtIdColor
             if (MapIdExtIdColor.containsKey(objInve.TAM_IdExterno__c))
             	MapIdExtIdColor.get(objInve.TAM_IdExterno__c).add(sIdColExtIdColInt);
             if (!MapIdExtIdColor.containsKey(objInve.TAM_IdExterno__c))
             	MapIdExtIdColor.put(objInve.TAM_IdExterno__c, new Set<String>{sIdColExtIdColInt});
        }                                                            
		System.debug('EN getDistribuidores getModelos mapIdExtTotal: ' + mapIdExtTotal);

		Set<String> setIdExterno = new Set<String>();
		for(CatalogoCentralizadoModelos__c objModelo : [  SELECT Id, Name, Marca__c,Serie__c,
                                                         Modelo__c,AnioModelo__c,CodigoColorExterior__c,
                                                         CodigoColorInterior__c, DescripcionColorExterior__c,
                                                         DescripcionColorInterior__c,Version__c
                                                         FROM CatalogoCentralizadoModelos__c ORDER BY Name]) {
			String sIdExterno = objModelo.Modelo__c + '' + objModelo.AnioModelo__c;
			setIdExterno.add(sIdExterno);                                                            	
		}
		
       	Map<String, String> mapIdExtProdSerie = new Map<String, String>();
		//Cinsulta el catalogo de prodictos para que te traigas las series reales
		for (Product2 producto :   [Select p.Serie__r.Id_Externo_Serie__c, p.Serie__c, p.IdExternoProducto__c From Product2 p
				where IdExternoProducto__c IN : setIdExterno]){
			//System.debug('EN getDistribuidores getSeries producto.IdExternoProducto__c: ' + producto.IdExternoProducto__c);		
			//Agregalo al mapa de mapIdExtProdSerie
			mapIdExtProdSerie.put(producto.IdExternoProducto__c, producto.Serie__r.Id_Externo_Serie__c);
		}
		System.debug('EN getDistribuidores consultaDatosVinesInterc mapIdExtProdSerie: ' + mapIdExtProdSerie.keySet());
		System.debug('EN getDistribuidores consultaDatosVinesInterc mapIdExtProdSerie: ' + mapIdExtProdSerie.Values());
		
		Map<String, String> mapIdExtCatCetMod = new Map<String, String>();
		for (CatalogoCentralizadoModelos__c objPaso : [Select c.TAM_ColorExtColorInt__c, c.Modelo__c, c.DescripcionColorInterior__c, 
			  c.DescripcionColorExterior__c, c.CodigoColorInterior__c, c.CodigoColorExterior__c, c.AnioModelo__c, c.Serie__c
              FROM CatalogoCentralizadoModelos__c c
              Where TAM_ColorExtColorInt__c != null
              ORDER BY Name]){
              //Crea la llave externa
              String sIdExt = objPaso.Modelo__c + '' + objPaso.AnioModelo__c;
              String sColorExtColorInt = objPaso.TAM_ColorExtColorInt__c;
              //Ve si ya existe en MapIdModIdColDesc
              if (MapIdModIdColDesc.containsKey(sIdExt))
              	//Ve si existe la combinación de colores TAM_ColorExtColorInt__c
              	MapIdModIdColDesc.get(sIdExt).put(sColorExtColorInt, objPaso);              	
              //Ve si ya existe en MapIdModIdColDesc
              if (!MapIdModIdColDesc.containsKey(sIdExt))
              	MapIdModIdColDesc.put(sIdExt, new Map<string, CatalogoCentralizadoModelos__c>{sColorExtColorInt => objPaso});
              //String sIdExtCatCemMod = objPaso.Serie__c + '' + objPaso.AnioModelo__c + '' + objPaso.Modelo__c + '' + objPaso.TAM_ColorExtColorInt__c;
              String sIdExtCatCemMod = mapIdExtProdSerie.get(sIdExt) + '' + objPaso.AnioModelo__c + '' + objPaso.Modelo__c + '' + objPaso.TAM_ColorExtColorInt__c;              
              mapIdExtCatCetMod.put(sIdExtCatCemMod, objPaso.id);	                       				
		}
		System.debug('EN getDistribuidores getModelos MapIdModIdColDesc: ' + MapIdModIdColDesc);
		System.debug('EN getDistribuidores getModelos mapIdExtCatCetMod: ' + mapIdExtCatCetMod.KeySet());
		System.debug('EN getDistribuidores getModelos mapIdExtCatCetMod: ' + mapIdExtCatCetMod.Values());
		
		//Consulta los datos del detalle de vines
		Integer intCnt = 0;
		//Ya tienes la llave consulta los datos en TAM_VinesFlotillaPrograma__c
		for (TAM_VinesFlotillaPrograma__c objDistrib : [Select ID, Name, TAM_Cliente__r.Codigo_Distribuidor__c,
			TAM_Cliente__r.Name, TAM_IdExterno__c, TAM_DealerDaily__c, TAM_CanceladoPreviamente__c,
            TAM_SolicitudCanceladaPrevia__c, TAM_NoDealerIntercambio__c, TAM_Intercambio__c 
			From TAM_VinesFlotillaPrograma__c Where TAM_SolicitudFlotillaPrograma__c = :recordId 
            And (TAM_Intercambio__c = true OR TAM_CanceladoPreviamente__c = true
                OR TAM_DealerDaily__c = true)]){

			//Una variable de paso para el id externo
			String sTAMIdExterno = objDistrib.TAM_IdExterno__c;
			System.debug('EN getDistribuidores getModelos sTAMIdExterno: ' + sTAMIdExterno);
			//Destrulle el TAM_IdExterno__c separandolo por los guienes en un arreglo
			String[] slDatosModelo = sTAMIdExterno.split('-');
			
			//Ve si la longiutud del arreglo es mayor a 0
			if (slDatosModelo.size() > 0){
				
				//a1w3F000001ZCqzQAG-2020-COROLLA HV-1780-LE HV-1F7-20-JTDBBRBEXLJ019654-0123F0000018JKoQAM
				String strCodigoModelo = slDatosModelo[3] + '' + slDatosModelo[1];
				String strIdColor = '';
				if (slDatosModelo.size() == 8)
					strIdColor = slDatosModelo[4] + '' + slDatosModelo[5];
				if (slDatosModelo.size() == 9)
					strIdColor = slDatosModelo[5] + '' + slDatosModelo[6];					
				
				//Buaca el sIdExterno en MapIdModIdColDesc
				Map<string, CatalogoCentralizadoModelos__c> objMapCatCentMod = new Map<string, CatalogoCentralizadoModelos__c>();
				CatalogoCentralizadoModelos__c CatCentMod = new CatalogoCentralizadoModelos__c();
				if (MapIdModIdColDesc.containsKey(strCodigoModelo))
					 objMapCatCentMod = MapIdModIdColDesc.get(strCodigoModelo);
				System.debug('EN getDistribuidores getModelos objMapCatCentMod: ' + objMapCatCentMod);
				
				//Busca la clave de strIdColor en el mapa de  objMapCatCentMod
				if (objMapCatCentMod.containsKey(strIdColor))
					CatCentMod = objMapCatCentMod.get(strIdColor);
				
				System.debug('EN getDistribuidores getModelos slDatosModelo: ' + slDatosModelo + ' size: ' + slDatosModelo.size());		 		
				System.debug('EN getDistribuidores getModelos strCodigoModelo: ' + strCodigoModelo + ' strIdColor: ' + strIdColor );		 	
				System.debug('EN getDistribuidores getModelos CatCentMod: ' + CatCentMod.DescripcionColorExterior__c + ' ' + CatCentMod.DescripcionColorInterior__c);
				//CatalogoCentralizadoModelos__c:{TAM_ColorExtColorInt__c=1K320, Modelo__c=1793, DescripcionColorInterior__c=Negro, DescripcionColorExterior__c=Gris Metálico, CodigoColorInterior__c=20, CodigoColorExterior__c=1K3, AnioModelo__c=2020, Id=a1i3F000001nf8MQAQ}
				//a1t3F0000015c6DQAQ, 2020, COROLLA HV, 1780, 70, 20, JTDBBRBE1LJ018487, 0123F0000018JKjQAM
					
				String sMarca = 'Toyota';
				String sSerie = slDatosModelo[2];
				String sModelo = slDatosModelo[3];
				String sAnioModelo = slDatosModelo[1];
				String sVersion = '';
				String sCodigoColorExterior = slDatosModelo[4] + ' ' + CatCentMod.DescripcionColorExterior__c;
				String sCodigoColorInterior = slDatosModelo[5] + ' ' + CatCentMod.DescripcionColorInterior__c; 
				String sVin = slDatosModelo[6];
				String sDealerCode = objDistrib.TAM_NoDealerIntercambio__c;
					            
	            //Crea el objeto del tipo TAM_OrdenDeCompraWrapperClass
				TAM_OrdenDeCompraWrapperClass objWrpOrdCompPaso = new TAM_OrdenDeCompraWrapperClass(
	            			sMarca,
	                        sSerie,
	                        sModelo,
	                        sAnioModelo,
	                        sVersion,
	                        slDatosModelo[4],
	                        slDatosModelo[5],
	                        CatCentMod.DescripcionColorExterior__c, //Desc color ext
	                        CatCentMod.DescripcionColorInterior__c, //Desc color int
	                        null, //strCantidad
	                        null, //strDescuentoDealer
	                        String.valueOf(mapPriceBookEntry.get(strCodigoModelo)), //strPrecioSinIVA
	                        null, //strSubtotal
	                        sSerie + '-' + sModelo + '-' + sAnioModelo + '-' + sCodigoColorExterior + '-' + sCodigoColorInterior + '-' + sVersion, //strName
	                        sSerie + '-' + sVersion + '-' + sModelo + '-' + sAnioModelo, //strNameCustom
	                        sCodigoColorExterior + '-' + '', //strColorExteriorCustom
	                        sCodigoColorInterior + '-' + '', //strColorInteriorCustom
	                        false //boolDistribuidoraActual
                );
                
                //Inicializa el vin
                objWrpOrdCompPaso.strVin = sVin;
                objWrpOrdCompPaso.strNoDealer = sDealerCode;
                objWrpOrdCompPaso.blnIntercambio = objDistrib.TAM_Intercambio__c;
                objWrpOrdCompPaso.boolDistribuidoraActual = false;
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.blnDd = objDistrib.TAM_DealerDaily__c;
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.blnCancel = objDistrib.TAM_CanceladoPreviamente__c;
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.strSolName = objDistrib.TAM_SolicitudCanceladaPrevia__c;
                
                String sIdExtCatModCet = slDatosModelo[2] + '' + slDatosModelo[1] + '' + slDatosModelo[3] + '' + slDatosModelo[4] + '' + slDatosModelo[5];
				System.debug('EN getDistribuidores getModelos sIdExtCatModCet: ' + sIdExtCatModCet);
				
                objWrpOrdCompPaso.strIdCatModelos = mapIdExtCatCetMod.containsKey(sIdExtCatModCet) ?  mapIdExtCatCetMod.get(sIdExtCatModCet) : null;
                System.debug('EN getDistribuidores getModelos objWrpOrdCompPaso.strIdCatModelos: ' + objWrpOrdCompPaso.strIdCatModelos);
                
				//Agregalo a la lista 
				lObjWrpDist.add(objWrpOrdCompPaso);
			}//Fin si slDatosModelo.length() > 0			
		}//fin del for para TAM_VinesFlotillaPrograma__c
		System.debug('EN consultaDatosVinesInterc lObjWrpDist: ' + lObjWrpDist);	
						  	        
        //serializa la lista y crea el JSON
		slObjWrpDist = JSON.serialize(lObjWrpDist);
        System.debug('EN consultaDatosVinesInterc objRespoPaso: ' + slObjWrpDist);
                 
        //Regresa la cadena
        return lObjWrpDist;
    }  

    public static Map<String,Double>  ObtenerPrecios(){

         //Obtiene mes y año para buscar la lista de precios correspondiente.
        Date fechaActual = System.today();
        String strAnio = String.valueOf(fechaActual.year());
        Integer intMesActual = fechaActual.month();
        Map<Integer,String> mapMes = new Map<Integer,String>();
        mapMes.put(1, 'ENERO');
        mapMes.put(2, 'FEBRERO');
        mapMes.put(3, 'MARZO');
        mapMes.put(4, 'ABRIL');
        mapMes.put(5, 'MAYO');
        mapMes.put(6, 'JUNIO');
        mapMes.put(7, 'JULIO');
        mapMes.put(8, 'AGOSTO');
        mapMes.put(9, 'SEPTIEMBRE');
        mapMes.put(10, 'OCTUBRE');
        mapMes.put(11, 'NOVIEMBRE');
        mapMes.put(12, 'DICIEMBRE');

        String strMes = mapMes.get(intMesActual);
        String strNombreCatalogoPrecios = 'VH-' + strMes + '-' + strAnio;

        System.debug('**** CODIGO PRECIO******* ' + strNombreCatalogoPrecios);

        //Mapa de catálogo de lista de precios.
        List<PricebookEntry> lstCatalogoPrecios = [ SELECT  Id,
                                                            ProductCode,
                                                            PrecioSinIva__c
                                                    FROM    PricebookEntry
                                                    WHERE   IsActive = true AND Pricebook2.Name =:strNombreCatalogoPrecios
        ];
        System.debug('**** TAMAÑO LISTA PRICEBOOK ******* ' + lstCatalogoPrecios.size());

        String strCodigoProducto;
        Double dblPrecioSinIVA;
        Map<String,Double> mapPriceBookEntry = new Map<String,Double>();
        for(PricebookEntry objListaPrecio : lstCatalogoPrecios){
            strCodigoProducto = objListaPrecio.ProductCode;
            dblPrecioSinIVA = objListaPrecio.PrecioSinIva__c;
            mapPriceBookEntry.put(strCodigoProducto, dblPrecioSinIVA);
        }
        return mapPriceBookEntry;
    }

  
    //Obtener un Set de las series disponibles
    @AuraEnabled
    public static TAM_WrpResultadoActualizacion saveDatosModelos(String sWrpDist, String recordId,
    	List<TAM_OrdenDeCompraWrapperClass> sWrpDistInter) {    	
    	System.debug('EN saveDatos sWrpDist: ' + sWrpDist );
    	System.debug('EN saveDatos recordId: ' + recordId);
    	System.debug('EN saveDatos sWrpDistInter: ' + sWrpDistInter);

    	String sMensaejeSalidaUpd = '';  
		Map<String, TAM_VinesFlotillaPrograma__c> mapVinesFlotProgInter = new Map<String, TAM_VinesFlotillaPrograma__c>();
		
		TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
		List<TAM_OrdenDeCompraWrapperClass> lObjWrpDist = new List<TAM_OrdenDeCompraWrapperClass>();		
		List<TAM_DetalleOrdenCompra__c>	ListDistProgUps = new List<TAM_DetalleOrdenCompra__c>();
		Set<String> setCaveDistr = new Set<String>();
		
		List<TAM_WrpDistSolFlotillaPrograma> lObjWrpDistElim = new List<TAM_WrpDistSolFlotillaPrograma>();
		Set<String> setCaveDistrElim = new Set<String>();
		List<TAM_OrdenDeCompraWrapperClass>	ListDistProgDel = new List<TAM_OrdenDeCompraWrapperClass>();
		Map<String, String> mapVinInvIntercDealer = new Map<String, String>();
        Set<String> setVinesConforma = new Set<String>();
        Set<String> setVinesOftaPublica = new Set<String>();
        Set<String> setVinesOftaPublicaMismoDealer = new Set<String>();
        
		String strSolRecortTypeId = getTipoRegSol(recordId);
		System.debug('EN saveDatosModelos strSolRecortTypeId: ' + strSolRecortTypeId );

		String sRectorTypePaso = getTipoRegSol(strSolRecortTypeId, true);
		System.debug('EN saveDatosModelosModelos sRectorTypePaso: ' + sRectorTypePaso );		

		String sRectorTypePasoIdExt = getTipoRegSol(strSolRecortTypeId, false);
		System.debug('EN saveDatosModelos sRectorTypePasoIdExt: ' + sRectorTypePasoIdExt );		
		
		User usuarioActual = new User();
        //Los datos del distribuidor
        for (User usuario : [Select u.id, u.Name, u.CodigoDistribuidor__c, u.Email
            From User u Where id = :UserInfo.getUserId() and CodigoDistribuidor__c != null]){
            usuarioActual = usuario;
        }//Fin del for para User
        String sCodigoDistribuidor = usuarioActual.CodigoDistribuidor__c != null ? usuarioActual.CodigoDistribuidor__c : '57000'; 
				
		//Ve si tiene algo la lista 
		lObjWrpDist = JSONParserSFDC(sWrpDist);
				
		//Crea el Mapa para los registros del objeto  TAM_DetalleOrdenCompra__c
		Map<String, TAM_DetalleOrdenCompra__c> mapTAMDetalleOrdenCompra = new Map<String, TAM_DetalleOrdenCompra__c>();
		
		//Recorre la lista de inmventario en piso
		for (TAM_OrdenDeCompraWrapperClass objWrpDist : lObjWrpDist){
			//Solo los que son mayor a 0
			System.debug('EN saveDatosModelos objWrpDist: ' + objWrpDist);
			
			//String sRecordName = objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strVersion + ' ' + objWrpDist.strModelo + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior;
			String sRecordName = objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strModelo + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior;
			//String sIdExterno = recordId + '-' + objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strModelo + '-' + objWrpDist.strVersion + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior + '-' + sRectorTypePasoInventario;
			String sIdExterno = recordId + '-' + objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strModelo + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior + '-' + sRectorTypePaso;
			System.debug('EN saveDatosModelos sIdExterno: ' + sIdExterno);
			
			//Ve si no existe en el mapa de mapTAMDetalleOrdenCompra el reg
			if (!mapTAMDetalleOrdenCompra.containsKey(sIdExterno)){
				//Crea el objeto del tipo objPaso
				TAM_DetalleOrdenCompra__c objPaso = new TAM_DetalleOrdenCompra__c(
						Name = sRecordName,
						RecordTypeid = sRectorTypePasoInventario,
						TAM_Cantidad__c = (objWrpDist.strCantidad != null && objWrpDist.strCantidad != '') ? Integer.valueOf(objWrpDist.strCantidad) : 0,
						TAM_EstatusDealerSolicitud__c = 'Pendiente',
						TAM_FechaSolicitud__c = Date.today(),
						TAM_SolicitudFlotillaPrograma__c = recordId,
						TAM_CatalogoCentralizadoModelos__c = (objWrpDist.strIdCatModelos != null && objWrpDist.strIdCatModelos != '') ? objWrpDist.strIdCatModelos : null,
						TAM_IdExterno__c = sIdExterno,
						TAM_EntregarEnMiDistribuidora__c = objWrpDist.boolDistribuidoraActual
				);
				//Crea el registro y agregalo a la lista de ListDistProgUps
				mapTAMDetalleOrdenCompra.put(sIdExterno, objPaso);
			}//Fin si !mapTAMDetalleOrdenCompra.containsKey(sIdExterno			
            //Mete los vines al set de 
            setVinesConforma.add(objWrpDist.strVin);
		}//Fin del for para lObjWrpDist
   		System.debug('EN saveDatosModelos mapTAMDetalleOrdenCompra0: ' + mapTAMDetalleOrdenCompra.KeySet());
   		System.debug('EN saveDatosModelos mapTAMDetalleOrdenCompra0: ' + mapTAMDetalleOrdenCompra.Values());
        System.debug('EN saveDatosModelos setVinesConforma0: ' + setVinesConforma);

		//Recorre la lista de sWrpDistInter para los de intercanbio
		for (TAM_OrdenDeCompraWrapperClass objWrpDist : sWrpDistInter){
			//Solo los que son mayor a 0
			System.debug('EN saveDatosModelos objWrpDist: ' + objWrpDist);
			
			//String sRecordName = objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strVersion + ' ' + objWrpDist.strModelo + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior;
			String sRecordName = objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strModelo + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior;
			//String sIdExterno = recordId + '-' + objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strModelo + '-' + objWrpDist.strVersion + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior + '-' + sRectorTypePasoInventario;
			String sIdExterno = recordId + '-' + objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strModelo + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior + '-' + sRectorTypePaso;
			System.debug('EN saveDatosModelos sIdExterno: ' + sIdExterno);
			
			//Ve si no existe en el mapa de mapTAMDetalleOrdenCompra el reg
			if (!mapTAMDetalleOrdenCompra.containsKey(sIdExterno) || Test.isRunningTest()){
				//Crea el objeto del tipo objPaso
				TAM_DetalleOrdenCompra__c objPaso = new TAM_DetalleOrdenCompra__c(
						Name = sRecordName,
						RecordTypeid = sRectorTypePasoInventario,
						TAM_Cantidad__c = (objWrpDist.strCantidad != null && objWrpDist.strCantidad != '') ? Integer.valueOf(objWrpDist.strCantidad): 1,
						TAM_EstatusDealerSolicitud__c = 'Pendiente',
						TAM_FechaSolicitud__c = Date.today(),
						TAM_SolicitudFlotillaPrograma__c = recordId,
						TAM_CatalogoCentralizadoModelos__c = (objWrpDist.strIdCatModelos != null && objWrpDist.strIdCatModelos != '') ? objWrpDist.strIdCatModelos : null,
						TAM_IdExterno__c = sIdExterno,
						TAM_EntregarEnMiDistribuidora__c = objWrpDist.boolDistribuidoraActual
				);
				//Crea el registro y agregalo a la lista de ListDistProgUps
				mapTAMDetalleOrdenCompra.put(sIdExterno, objPaso);				
			}//Fin si !mapTAMDetalleOrdenCompra.containsKey(sIdExterno
			//Ya existe esa llave asi que esta seleccionando mas de un VIN
            if (mapTAMDetalleOrdenCompra.containsKey(sIdExterno) || Test.isRunningTest()){
                Decimal iCntCantidad = mapTAMDetalleOrdenCompra.get(sIdExterno).TAM_Cantidad__c;
                mapTAMDetalleOrdenCompra.get(sIdExterno).TAM_Cantidad__c = iCntCantidad + 1;                
            }//Fin si mapTAMDetalleOrdenCompra.containsKey(sIdExterno) || Test.isRunningTest()

            //Crea el registro del tipo
            String sIdExternoInterc = recordId + '-' + objWrpDist.strAnioModelo + '-' +  objWrpDist.strSerie + '-' + objWrpDist.strModelo + '-' + objWrpDist.strCodigoColorExterior + '-' + objWrpDist.strCodigoColorInterior + '-' + objWrpDist.strVin + '-' + sRectorTypePasoIdExt;
            System.debug('EN saveDatosModelos sIdExternoInterc: ' + sIdExternoInterc);  
            //Crea el registro y agregalo a la lista de ListDistProgUps
            TAM_VinesFlotillaPrograma__c objPasoVinInter = new TAM_VinesFlotillaPrograma__c(
                        Name = objWrpDist.strVin,
                        TAM_SolicitudFlotillaPrograma__c = recordId,
                        RecordTypeid = sRectorTypePaso, //sRectorTypePasoPrograma,
                        TAM_Estatus__c = 'Pendiente',
                        TAM_IdExterno__c = sIdExternoInterc,
                        TAM_EstatusInventario__c = 'Piso',
                        TAM_Intercambio__c = objWrpDist.blnIntercambio,
                        TAM_NoDealerIntercambio__c = objWrpDist.strNoDealer,
                        TAM_DealerDaily__c = objWrpDist.blnDd,
                        TAM_CanceladoPreviamente__c = objWrpDist.blnCancel,
                        TAM_SolicitudCanceladaPrevia__c = objWrpDist.strSolName 
            );
            //Metelo al mapa de mapVinesFlotProgInter
            mapVinesFlotProgInter.put(sIdExternoInterc, objPasoVinInter);
			
			//Mete los vines al set de 
			setVinesConforma.add(objWrpDist.strVin);
			
		}//Fin del for para lObjWrpDist
   		System.debug('EN saveDatosModelos mapTAMDetalleOrdenCompra1: ' + mapTAMDetalleOrdenCompra.KeySet());
   		System.debug('EN saveDatosModelos mapTAMDetalleOrdenCompra1: ' + mapTAMDetalleOrdenCompra.Values());
   		System.debug('EN saveDatosModelos mapVinesFlotProgInter1: ' + mapVinesFlotProgInter.KeySet());
   		System.debug('EN saveDatosModelos mapVinesFlotProgInter1: ' + mapVinesFlotProgInter.Values());
        System.debug('EN saveDatosModelos setVinesConforma1: ' + setVinesConforma);

		//Crea un SP
		SavePoint sp = Database.setSavePoint();
		try{
			
			//Ve si alguno de los vines del set setVinesConforma esta en una solicitud en DOD
            for (TAM_DODSolicitudesPedidoEspecial__c objDodOfertaPubl : [Select t.TAM_VIN__c, 
                t.TAM_Oferta_Publica__c, t.TAM_ClaveDealer__c, TAM_Enviado_Oferta_Publica__c 
                From TAM_DODSolicitudesPedidoEspecial__c t Where TAM_VIN__c IN :setVinesConforma]){
                //Es el mismo distribuidor no esta liberado por Lucio ni edoarado    
                if (objDodOfertaPubl.TAM_ClaveDealer__c == sCodigoDistribuidor && objDodOfertaPubl.TAM_Oferta_Publica__c
                   && !objDodOfertaPubl.TAM_Enviado_Oferta_Publica__c){
                   setVinesOftaPublica.add(objDodOfertaPubl.TAM_VIN__c);
                    System.debug('EN saveDatosModelos VAL 1...');    
                }
                //Es diferente distribuidor no esta liberado por Lucio   
                if (objDodOfertaPubl.TAM_ClaveDealer__c != sCodigoDistribuidor && objDodOfertaPubl.TAM_Oferta_Publica__c
                   && !objDodOfertaPubl.TAM_Enviado_Oferta_Publica__c){
                   setVinesOftaPublica.add(objDodOfertaPubl.TAM_VIN__c);
                    System.debug('EN saveDatosModelos VAL 2...');    
                }
                //Es el mismo distribuidor y esta liberado por Lucio para oferta publica
                if (objDodOfertaPubl.TAM_ClaveDealer__c == sCodigoDistribuidor && objDodOfertaPubl.TAM_Oferta_Publica__c
                   && objDodOfertaPubl.TAM_Enviado_Oferta_Publica__c){
                   setVinesOftaPublicaMismoDealer.add(objDodOfertaPubl.TAM_VIN__c);
                    System.debug('EN saveDatosModelos VAL 3...');    
                }
            }//Fin del for para TAM_DODSolicitudesPedidoEspecial__c
                    						
			//Inserta los datos de los vines de intercambio en  TAM_VinesFlotillaPrograma__c
	    	Set<String> setIdVinesInterc = new Set<String>();			
	    	//Ve si tiene algo la lista de ListDistProgUps
	    	if (!mapVinesFlotProgInter.isEmpty()){
		        //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
				List<Database.Upsertresult> lDtbUpsRes = Database.upsert(mapVinesFlotProgInter.values(), TAM_VinesFlotillaPrograma__c.TAM_IdExterno__c, false);
				//Ve si hubo error
				for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess())
						objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de crear/Actualizar los registros de los TAM_VinesFlotillaPrograma ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
					if (objDtbUpsRes.isSuccess()){
						setIdVinesInterc.add(objDtbUpsRes.getId());
						objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'Los datos de los TAM_VinesFlotillaPrograma seleccionados se crearon/Actualizar con exito');
					}	
				}//Fin del for para lDtbUpsRes
	    	} //Fin si ListDistProgUps.isEmpty()
	    	System.debug('EN saveDatosModelos setIdVinesInterc: ' + setIdVinesInterc);
			System.debug('EN saveDatosModelos objRespoPaso.strDetalle: ' + objRespoPaso.strDetalle);		  	
			
			Map<String, TAM_DetalleOrdenCompra__c> mapIdSfdcObjDetDel = new Map<String, TAM_DetalleOrdenCompra__c>();
			String sIdSol = recordId + '%';
			//Antes de agregrar o actualizar el detalle de la compra por inventario elimina loe reg que ya existen
		  	for (TAM_DetalleOrdenCompra__c objTAMVinesFlotillaPrograma : [Select id	From TAM_DetalleOrdenCompra__c 
		  		Where TAM_IdExterno__c LIKE :sIdSol and RecordTypeid =:sRectorTypePasoInventario ]){
		  		mapIdSfdcObjDetDel.put(objTAMVinesFlotillaPrograma.id, objTAMVinesFlotillaPrograma);	
		  	}
			System.debug('EN saveDatosModelos mapIdSfdcObjDetDel: ' + mapIdSfdcObjDetDel);
			
	    	Set<String> setIdNuevosRegDetDel = new Set<String>();
	    	//Ve si tiene algo la lista de ListDistProgUps
	    	if (!mapIdSfdcObjDetDel.isEmpty()){
		        //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
				List<Database.deleteresult> lDtbUpsRes = Database.delete(mapIdSfdcObjDetDel.values(), false);
				//Ve si hubo error
				for (Database.deleteresult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess())
						objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de crear/Actualizar los registros de los Modelos ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
					if (objDtbUpsRes.isSuccess()){
						setIdNuevosRegDetDel.add(objDtbUpsRes.getId());
						objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'Los datos de los Modelos seleccionados se crearon/Actualizar con exito');
					}	
				}//Fin del for para lDtbUpsRes
	    	} //Fin si ListDistProgUps.isEmpty()
	    	System.debug('EN saveDatosModelos setIdNuevosRegDetDel: ' + setIdNuevosRegDetDel);
			System.debug('EN saveDatosModelos objRespoPaso.strDetalle: ' + objRespoPaso.strDetalle);		  	
			
	    	Set<String> setIdNuevosReg = new Set<String>();
	    	//Ve si tiene algo la lista de ListDistProgUps
	    	if (!mapTAMDetalleOrdenCompra.isEmpty()){
		        //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
				List<Database.Upsertresult> lDtbUpsRes = Database.upsert(mapTAMDetalleOrdenCompra.values(), TAM_DetalleOrdenCompra__c.TAM_IdExterno__c, false);
				//Ve si hubo error
				for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess())
						objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de crear/Actualizar los registros de los Modelos ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
					if (objDtbUpsRes.isSuccess()){
						setIdNuevosReg.add(objDtbUpsRes.getId());
						objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'Los datos de los Modelos seleccionados se crear/Actualizar con exito');
					}	
				}//Fin del for para lDtbUpsRes
	    	} //Fin si ListDistProgUps.isEmpty()
	    	System.debug('EN saveDatosModelos objRespoPaso.setIdNuevosReg: ' + setIdNuevosReg);
			System.debug('EN saveDatosModelos objRespoPaso.strDetalle: ' + objRespoPaso.strDetalle);
		  	
		  	Map<String, String> mapIdSfdcIdExt = new Map<String, String>();
		  	//Conculta los reg que acabas de crear y obten su ID EXTERNO
		  	for (TAM_DetalleOrdenCompra__c objTAMDetalleOrdenCompra : [Select id, TAM_IdExterno__c From TAM_DetalleOrdenCompra__c
		  		Where id IN : setIdNuevosReg]){
		  		String sIdExt = objTAMDetalleOrdenCompra.TAM_IdExterno__c;
		  		String sIdExtFinal = sIdExt.substring(0, sIdExt.lastIndexOf('-'));
		  		mapIdSfdcIdExt.put(sIdExtFinal, objTAMDetalleOrdenCompra.id);
		  	}
	    	System.debug('EN saveDatosModelos mapIdSfdcIdExt: ' + mapIdSfdcIdExt);
		  	
		  	Map<String, TAM_VinesFlotillaPrograma__c> mapVinesUps = new Map<String, TAM_VinesFlotillaPrograma__c>();
		  	//Recorre la lista de id externo del mapa mapIdSfdcIdExt
		  	for (String sIdExtPaso : mapIdSfdcIdExt.keySet()){
		  		Boolean bExiste = false;
				String ssIdExtCons = sIdExtPaso + '%';
				System.debug('EN saveDatosModelos ssIdExtCons: ' + ssIdExtCons + ' sIdExtPaso: ' + sIdExtPaso);
				
			  	//Ya que tienes los registros que acabas de actualizar
			  	for (TAM_VinesFlotillaPrograma__c objTAMVinesFlotillaPrograma : [Select id
			  		//,TAM_DetalleSolicitudCompra_FLOTILLA__c 
			  		From TAM_VinesFlotillaPrograma__c
			  		Where TAM_IdExterno__c LIKE :ssIdExtCons]){
			  		bExiste = true;
			  		TAM_VinesFlotillaPrograma__c objVinesPaso = new TAM_VinesFlotillaPrograma__c(id = objTAMVinesFlotillaPrograma.id
			  			,TAM_DetalleSolicitudCompra__c = mapIdSfdcIdExt.get(sIdExtPaso)
			  		);
			  		//Crea la relacion del detalle con los vines
			  		mapVinesUps.put(objTAMVinesFlotillaPrograma.id , objVinesPaso);
			  	}
			  	if (!bExiste){
			  		String sNamePaso = sIdExtPaso.length() > 80 ? sIdExtPaso.substring(0,79) : sIdExtPaso;
			  		TAM_VinesFlotillaPrograma__c objVinesPaso = new TAM_VinesFlotillaPrograma__c(Name = sNamePaso,
			  			TAM_IdExterno__c = ssIdExtCons, TAM_DetalleSolicitudCompra__c = mapIdSfdcIdExt.get(sIdExtPaso)
			  		);
			  		//Agregalo al mapa  de mapVinesUps
			  		mapVinesUps.put(ssIdExtCons , objVinesPaso);	
			  	}//fIN SI !bExiste
			  	
		  	}//Fin del for para mapIdSfdcIdExt.keySet()
		  	System.debug('EN saveDatosModelos mapVinesUps: ' + mapVinesUps);
		  	
	    	Set<String> setIdNuevosRegVin = new Set<String>();
	    	//Ve si tiene algo la lista de ListDistProgUps
	    	if (!mapVinesUps.isEmpty()){
		        //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
				List<Database.Upsertresult> lDtbUpsRes = Database.upsert(mapVinesUps.values(), TAM_VinesFlotillaPrograma__c.id, false);
				//Ve si hubo error
				for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess())
						objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de crear/Actualizar los registros de los Modelos ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
					if (objDtbUpsRes.isSuccess()){
						setIdNuevosRegVin.add(objDtbUpsRes.getId());
						objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'Los datos de los Modelos seleccionados se crear/Actualizar con exito');
					}	
				}//Fin del for para lDtbUpsRes
	    	} //Fin si ListDistProgUps.isEmpty()
	    	System.debug('EN saveDatosModelos setIdNuevosRegVin: ' + setIdNuevosRegVin);
			System.debug('EN saveDatosModelos objRespoPaso.strDetalle: ' + objRespoPaso.strDetalle);		  	
		  	
		  	Set<String> setVinInsert = new Set<String>(); 
		  	//Ve si alguno de los vones ya esta ocupadoa en otra solicitud y esta cerrada
		  	for (TAM_VinesFlotillaPrograma__c objTAMVinesFlotillaPrograma : [Select id, Name
		  		From TAM_VinesFlotillaPrograma__c Where TAM_SolicitudFlotillaPrograma__c =: recordId]){
		  		//Crea la relacion del detalle con los vines
		  		setVinInsert.add(objTAMVinesFlotillaPrograma.Name);
		  	}//Fin del for para objTAMVinesFlotillaPrograma
			System.debug('EN saveDatosModelos setVinInsert: ' + setVinInsert);		  	
		  	
		  	List<TAM_VinesFlotillaPrograma__c> lstVinDupDel = new List<TAM_VinesFlotillaPrograma__c>();
		  	//Ve si alguno de los vines esta enotra orden y ya esta cerrada
		  	for (TAM_VinesFlotillaPrograma__c objSolFlotProg : [Select t.Name, t.Id From TAM_VinesFlotillaPrograma__c t 
		  			Where TAM_SolicitudFlotillaPrograma__c != : recordId
		  			And TAM_SolicitudFlotillaPrograma__r.TAM_Estatus__c = 'Cerrada' And Name IN:setVinInsert ]){
		  		//Metelos al set de lstVinDupDel
		  		lstVinDupDel.add(new TAM_VinesFlotillaPrograma__c(id = objSolFlotProg.id));
		  	}
			System.debug('EN saveDatosModelos lstVinDupDel: ' + lstVinDupDel);		  	
		  	
		  	//Ve si tiene algo lstVinDupDel entonces elimina los reg
		  	if (!lstVinDupDel.isEmpty())
		  		delete lstVinDupDel; 
		  			  	        
 		}catch(Exception ex){
			System.debug(LoggingLevel.INFO,'EN saveDatosModelos ERROR getMessage: ' + ex.getMessage() + ' getLineNumber: ' + ex.getLineNumber());
			objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de crear/Actualizar los registros de los Modelos ERROR: ' + ex.getMessage() + ' en la linea: ' + ex.getLineNumber());
			//Alica el rollback
			Database.rollback(sp);
		}

        System.debug(LoggingLevel.INFO,'EN saveDatosModelos setVinesOftaPublica: ' + setVinesOftaPublica);        
        //Ve si ha vines en oferta publica y marca del error:
        if (!setVinesOftaPublica.isEmpty()){
            String lVinesFinal = '';
            for (String sVinesPaso : setVinesOftaPublica){
                lVinesFinal += sVinesPaso + ', '; 
            }
            objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Error. Los siguientes VINES están en oferta pública: ' + lVinesFinal + ' Por lo tanto no puedes seleccionarlos. \n Ponte en contacto con ' + System.Label.TAM_ResponsablesOfertaPublica);
            Database.rollback(sp);
        }//Fin si !setVinesOftaPublica.isEmpty()


        //Ve si ha vines en oferta publica y marca del error:
        if (!setVinesOftaPublicaMismoDealer.isEmpty()){
            String lVinesFinal = '';
            for (String sVinesPaso : setVinesOftaPublicaMismoDealer){
                lVinesFinal += sVinesPaso + ', '; 
            }
            objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Error. Los siguientes VINES están en oferta pública: ' + lVinesFinal + ' Por lo tanto no puedes seleccionarlos.');
            Database.rollback(sp);
        }//Fin si !setVinesOftaPublica.isEmpty()
        
		//HECHA PARA ATRAS TODO PORQUE ES UNA PRUEBA
		//Database.rollback(sp);
               
        System.debug('EN getWrpModelo objRespoPaso: ' + objRespoPaso);
        //Regresa la cadena
        return objRespoPaso;
    }

	//Regresa un objeto del tipo AddTelephoneDto si no hubo error a la hora de registrar el cliente		
	public static List<TAM_OrdenDeCompraWrapperClass> JSONParserSFDC(String sJsonResp){
		System.debug('EN JSONParserSFDC: sJsonResp: ' + sJsonResp);
		
		List<TAM_OrdenDeCompraWrapperClass> listObjWrp = new List<TAM_OrdenDeCompraWrapperClass>();
		try{
            JSONParser parser = JSON.createParser(sJsonResp);
            //Ve si tiene algo el objeto de parser  
            while (parser.nextToken() != null) {//[{"boolBalanceOut":false,"boolClonado":false,"boolPagoTFS":false,"boolTriplePlay":false,"intDiasInventario":10,"intInventario":8,"intMSRP":100,"intTMEXMargen_Pesos":0,"intTMEXMargen_Porcentaje":0,"strAnioModelo":"2019","strClaveModelo":"2201","strSerie":"AVANZA","strVersion":"LE MT","strYear_Serie":"2019-AVANZA"},'{"boolBalanceOut":false,"boolClonado":false,"boolPagoTFS":false,"boolTriplePlay":false,"intDiasInventario":2,"intInventario":1,"intMSRP":100,"intTMEXMargen_Pesos":0,"intTMEXMargen_Porcentaje":0,"strAnioModelo":"2019","strClaveModelo":"2202","strSerie":"AVANZA","strVersion":"LE AT","strYear_Serie":"2019-AVANZA"} '']'
				//Inicia el detalle del objeto: sNombreObj
				if (parser.getCurrentToken() == JSONToken.START_OBJECT) {
					//Toma el contenido del Json y conviertelo a SignInCls.class 
					TAM_OrdenDeCompraWrapperClass objTAM_DetalleOrdenCompra = (TAM_OrdenDeCompraWrapperClass)parser.readValueAs(TAM_OrdenDeCompraWrapperClass.class);
					listObjWrp.add(objTAM_DetalleOrdenCompra);
				}//Fin si parser.getCurrentToken() == JSONToken.START_OBJECT
            }//Fin mientras parser.nextToken() != null			
		}catch(Exception ex){
			System.debug('ERROR EN JSONParserSFDC: sJsonResp: ' + ex.getMessage());
	 	}
		System.debug('ANTES DE SALIR DE JSONParserSFDC: listObjWrp: ' + listObjWrp);
			 	
		//Regresa el objeto objSignInClsPaso
		return listObjWrp;
	}    

    public static string getTipoRegSol(String sIdSol) {
    	System.debug('EN getTipoRegSol sIdSol: ' + sIdSol);
    	
    	String sTipoRegSolPaso = '';
    	String sTipoRegSol = '';
    	
    	//Consulta el tipo de reg de la solicitd
    	for (TAM_SolicitudesFlotillaPrograma__c objSol : [Select id, RecordTypeid From TAM_SolicitudesFlotillaPrograma__c Where id =: sIdSol]){
    		sTipoRegSol = objSol.RecordTypeid;
    	}  	
    	System.debug('EN getTipoRegSol sTipoRegSol: ' + sTipoRegSol);

    	sTipoRegSolPaso = sTipoRegSol == sRectorTypePasoSolPrograma ? sRectorTypePasoSolPrograma :
    		(sTipoRegSol == sRectorTypePasoSolProgramaCerrada ? sRectorTypePasoSolPrograma :
    			( sTipoRegSol == sRectorTypePasoSolVentaCorporativa ? sRectorTypePasoSolVentaCorporativa : 
    		 		( sTipoRegSol == sRectorTypePasoSolVentaCorporativaCerrada ? sRectorTypePasoSolVentaCorporativa : sRectorTypePasoSolPrograma)
    		 	) 
    		);
    			
		System.debug('EN getTipoRegSol sTipoRegSolPaso: ' + sTipoRegSolPaso);
        return sTipoRegSolPaso;
    }

    //Obtener distribuidores.
    @AuraEnabled
    public static List<TAM_OrdenDeCompraWrapperClass> agregaVinInter(String recordId, List<TAM_OrdenDeCompraWrapperClass> lstVinInter, String strNvoVinIntercambio) {
    	System.debug('EN getDistribuidores recordId: ' + recordId + ' strNvoVinIntercambio: ' + strNvoVinIntercambio);
		List<TAM_OrdenDeCompraWrapperClass> lObjWrpInvIntercam = new List<TAM_OrdenDeCompraWrapperClass>();
		lObjWrpInvIntercam = lstVinInter;
				
		Set<String> setIdExtModAnio = new Set<String>();
		String sModel_Number = '';
		String sModel_Year = '';
		Boolean blnExiste = false;
        Boolean blnExisteInvG = false;
        Boolean blnExisteInvGDealer = false;
        Boolean blnExisteOfertaPublica = false;
        Boolean blnDispOfertaPublica = false;
        
        Boolean blnNoDispOferPubMisDit = false;
        Boolean blnNoDispOferPubMismoCte = false;
        
        String sCodigoDistribuidor;
        String sIdCteSol = '';
        User usuarioActual = new User();
        
        //Los datos del distribuidor
        for (User usuario : [Select u.id, u.Name, u.CodigoDistribuidor__c, u.Email
                             From User u Where id = :UserInfo.getUserId() and CodigoDistribuidor__c != null]){
                             usuarioActual = usuario;
        }//Fin del for para User
        sCodigoDistribuidor = usuarioActual.CodigoDistribuidor__c != null ? usuarioActual.CodigoDistribuidor__c : '57000'; 

		//Recorre la lista y ve si ya exste es vin: strNvoVinIntercambio
		for (TAM_OrdenDeCompraWrapperClass objPaso : lstVinInter){
			//Ve si strVin es igual  a strNvoVinIntercambio
			if (objPaso.strVin == strNvoVinIntercambio){
				blnExiste = true;
				break;
			}//Fin si objPaso.strVin == strNvoVinIntercambio
		}
		
		//Consulta el inventario disponible
    	for (TAM_InventarioVehiculosToyota__c objInvPaso : [Select t.Model_Number__c, t.Model_Year__c,   
    			t.TAM_TipoInventarioLetra__c, Dealer_Code__c From TAM_InventarioVehiculosToyota__c t 
    			Where Name =: strNvoVinIntercambio And t.TAM_TipoInventarioLetra__c = 'G']){
    		String sIdExt = objInvPaso.Model_Number__c + '' + objInvPaso.Model_Year__c;
    		sModel_Number = objInvPaso.Model_Number__c;
    		sModel_Year = objInvPaso.Model_Year__c;
    		setIdExtModAnio.Add(sIdExt);
    		blnExisteInvG = true;
    		if (objInvPaso.Dealer_Code__c == sCodigoDistribuidor)
                blnExisteInvGDealer = true;
    	}
    	if (blnExisteInvGDealer)
            blnExisteInvG = false;    	   
		System.debug('EN agregaVinInter getModelos setIdExtModAnio: ' + setIdExtModAnio + ' sModel_Number: ' + sModel_Number + ' sModel_Year: ' + sModel_Year + ' blnExisteInvGDealer: ' + blnExisteInvGDealer + ' blnExisteInvG: ' + blnExisteInvG);
        
        Boolean bExisteDD = false;
        Vehiculo__c VehiculoVCons = new Vehiculo__c();
        //No existe en Inventario G buscalo en DD Vehiculos__c y Movimientos
        for (Vehiculo__c ventas : [Select v.id, v.Fecha_de_Venta__c, v.Name, 
             CodigoDistribuidor__c, Id_Externo__c,Modelo_b__c,Modelo__c,SerieAD__c,Tipo_de_vehiculo__c, 
             ColorExternoVehiculo__r.Name, ColorExternoVehiculo__r.CodigoColor__c, Modelo_b__r.Version__c,
             ColorInternoVehiculo__r.Name, ColorInternoVehiculo__r.CodigoColor__c, Producto__r.Name, 
             Producto__r.Anio__c From Vehiculo__c v Where Name = :strNvoVinIntercambio 
             And Estatus__c = 'RDR' And CodigoDistribuidor__c =: sCodigoDistribuidor ]){
             String sIdExt = ventas.Producto__r.Name + '' + ventas.Producto__r.Anio__c;
             sModel_Number = ventas.Producto__r.Name;
             sModel_Year = ventas.Producto__r.Anio__c;
             setIdExtModAnio.Add(sIdExt);
             //Agregalo al mapa de mapVinesVtas
             bExisteDD = true;
             VehiculoVCons = ventas;
        }
        System.debug('EN agregaVinInter getModelos bExisteDD: ' + bExisteDD + ' VehiculoVCons: ' + VehiculoVCons + ' ' + VehiculoVCons.ColorExternoVehiculo__r.Name + ' ' + VehiculoVCons.ColorExternoVehiculo__r.CodigoColor__c + ' ' + VehiculoVCons.ColorInternoVehiculo__r.Name + ' ' + VehiculoVCons.ColorInternoVehiculo__r.CodigoColor__c);

        TAM_CheckOutDetalleSolicitudCompra__c objCheckOutCons = new TAM_CheckOutDetalleSolicitudCompra__c();
        Boolean bExisteCheckOutCanceled = false;
        String strSolName = '';
        //Si existe en Vehiculo__c quiere decir que ya esta registrado como una venta
        for (TAM_CheckOutDetalleSolicitudCompra__c objCheckout : [Select id, TAM_EstatusEntrega__c,
            TAM_SolicitudFlotillaPrograma__r.Name, TAM_IdExterno__c, TAM_VIN__c, TAM_NombreDistribuidor__c,
            TAM_Descripcion_Color_Interior__c, TAM_Descripcion_Color_Exterior__c, TAM_Serie__c, TAM_Version__c,
            TAM_Modelo__c, TAM_Anio_Modelo__c
            From TAM_CheckOutDetalleSolicitudCompra__c 
            Where TAM_VIN__c =:strNvoVinIntercambio And (TAM_EstatusDealerSolicitud__c = 'Cancelada'
            OR TAM_EstatusEntrega__c = 'Cancelado') And TAM_NombreDistribuidor__c =: sCodigoDistribuidor]){
            bExisteCheckOutCanceled = true; 
            strSolName = objCheckout.TAM_SolicitudFlotillaPrograma__r.Name;
            objCheckOutCons = objCheckout;
            String sIdExt = objCheckout.TAM_Modelo__c + '' + objCheckout.TAM_Anio_Modelo__c;
            sModel_Number = objCheckout.TAM_Modelo__c;
            sModel_Year = objCheckout.TAM_Anio_Modelo__c;
            setIdExtModAnio.Add(sIdExt);            
        }
        System.debug('EN agregaVinInter getModelos bExisteCheckOutCanceled: ' + bExisteCheckOutCanceled + ' objCheckOutCons: ' + objCheckOutCons);
        System.debug('EN agregaVinInter getModelos setIdExtModAnio: ' + setIdExtModAnio + ' sModel_Number: ' + sModel_Number + ' sModel_Year: ' + sModel_Year);

        Map<String, String> mapIdExtProdSerie = new Map<String, String>();
        //Cinsulta el catalogo de prodictos para que te traigas las series reales
        for (Product2 producto :   [Select p.Serie__r.Id_Externo_Serie__c, p.Serie__c, p.IdExternoProducto__c From Product2 p
                where IdExternoProducto__c IN : setIdExtModAnio]){
            //Agregalo al mapa de mapIdExtProdSerie
            mapIdExtProdSerie.put(producto.IdExternoProducto__c, producto.Serie__r.Id_Externo_Serie__c);
        }
        System.debug('EN agregaVinInter agregaVinInter mapIdExtProdSerie: ' + mapIdExtProdSerie.keySet());
        System.debug('EN agregaVinInter agregaVinInter mapIdExtProdSerie: ' + mapIdExtProdSerie.Values());

        Map<String, String> mapIdExtCatCetMod = new Map<String, String>();
        for (CatalogoCentralizadoModelos__c objPaso : [Select c.TAM_ColorExtColorInt__c, c.Modelo__c, c.DescripcionColorInterior__c, 
              c.DescripcionColorExterior__c, c.CodigoColorInterior__c, c.CodigoColorExterior__c, c.AnioModelo__c, c.Serie__c
              FROM CatalogoCentralizadoModelos__c c Where TAM_ColorExtColorInt__c != null And Version__c != null 
              And Modelo__c = :sModel_Number And AnioModelo__c = :sModel_Year ORDER BY Name]){     
              String sIdExt = objPaso.Modelo__c + '' + objPaso.AnioModelo__c ;       
              //String sIdExtCatCemMod = objPaso.Serie__c + '' + objPaso.AnioModelo__c + '' + objPaso.Modelo__c + '' + objPaso.TAM_ColorExtColorInt__c;
              String sIdExtCatCemMod = mapIdExtProdSerie.get(sIdExt) + '' + objPaso.AnioModelo__c + '' + objPaso.Modelo__c + '' + objPaso.TAM_ColorExtColorInt__c;  
              System.debug('EN agregaVinInter objPaso sIdExtCatCemMod: ' + sIdExtCatCemMod);
              //Agregalo al mapa de mapIdExtCatCetMod                             
              mapIdExtCatCetMod.put(sIdExtCatCemMod, objPaso.id);
        }
        //System.debug('EN agregaVinInter getModelos mapIdExtCatCetMod: ' + mapIdExtCatCetMod.KeySet());
        //System.debug('EN agregaVinInter getModelos mapIdExtCatCetMod: ' + mapIdExtCatCetMod.Values());

        //Obten la lista de precios actual
        Map<String, Double> mapPriceBookEntry = ObtenerPrecios();
        for (TAM_InventarioVehiculosToyota__c objInvPaso : [Select t.Toms_Series_Name__c, t.Tipo_Inventario__c, t.TAM_Version__c,  
                t.TAM_IdExterno__c, t.TAM_DiasPiso__c, t.TAM_Assigned_Dealer__c, t.Numero_de_Orden__c, t.Name, t.Model_Year__c, 
                t.Model_Number__c, t.Interior_Color_Description__c, t.Interior_Color_Code__c, t.Exterior_Color_Description__c, 
                t.Exterior_Color_Code__c, t.Dummy_VIN__c, t.Distributor_Invoice_Date_MM_DD_YYYY__c, t.Dealer_Code__c,
                t.TAM_TipoInventarioLetra__c, TAM_ExteriorColorCodeF__c, TAM_InteriorColorCodeF__c 
                From TAM_InventarioVehiculosToyota__c t 
                Where Name =: strNvoVinIntercambio And t.TAM_TipoInventarioLetra__c = 'G']){
                
                String strCodigoModelo = objInvPaso.Model_Number__c + '' + objInvPaso.Model_Year__c; //slDatosModelo[3] + '' + slDatosModelo[1];
                String sMarca = 'Toyota';
                String sSerie = mapIdExtProdSerie.get(strCodigoModelo); //objInvPaso.Toms_Series_Name__c; //slDatosModelo[2];
                String sModelo = objInvPaso.Model_Number__c; //slDatosModelo[3];
                String sAnioModelo = objInvPaso.Model_Year__c; //slDatosModelo[1];
                String sVersion = objInvPaso.TAM_Version__c;
                String sCodigoColorExterior = objInvPaso.TAM_ExteriorColorCodeF__c + ' ' + objInvPaso.Exterior_Color_Description__c; //slDatosModelo[4] + ' ' + CatCentMod.DescripcionColorExterior__c;
                String sCodigoColorInterior = objInvPaso.TAM_InteriorColorCodeF__c + ' ' + objInvPaso.Interior_Color_Description__c; //slDatosModelo[5] + ' ' + CatCentMod.DescripcionColorInterior__c; 
                String sVin = objInvPaso.Name; //slDatosModelo[6];
                String sDealerCode = objInvPaso.Dealer_Code__c; //slDatosModelo[6];
            
                //Crea el objeto del tipo TAM_OrdenDeCompraWrapperClass
                TAM_OrdenDeCompraWrapperClass objWrpOrdCompPaso = new TAM_OrdenDeCompraWrapperClass(
                            sMarca,
                            sSerie,
                            sModelo,
                            sAnioModelo,
                            (sVersion != NULL ? sVersion : ''), //sVersion,
                            objInvPaso.TAM_ExteriorColorCodeF__c, //slDatosModelo[4],
                            objInvPaso.TAM_InteriorColorCodeF__c, //slDatosModelo[5],
                            objInvPaso.Exterior_Color_Description__c, //Desc color ext
                            objInvPaso.Interior_Color_Description__c, //Desc color int
                            '0', //strCantidad
                            null, //strDescuentoDealer
                            String.valueOf(mapPriceBookEntry.get(strCodigoModelo)), //strPrecioSinIVA
                            null, //strSubtotal
                            sSerie + '-' + sModelo + '-' + sAnioModelo + '-' + sCodigoColorExterior + '-' + sCodigoColorInterior + '-' + (sVersion != NULL ? sVersion : ''), //strName
                            sSerie + '-' + (sVersion != NULL ? sVersion : '') + '-' + sModelo + '-' + sAnioModelo, //strNameCustom
                            sCodigoColorExterior + '-' + '', //strColorExteriorCustom
                            sCodigoColorInterior + '-' + '', //strColorInteriorCustom
                            false //boolDistribuidoraActual
                );
                
                //Inicializa el vin
                objWrpOrdCompPaso.strVin = sVin;
                objWrpOrdCompPaso.strNoDealer = sDealerCode;
                //Si se trata de intercambio
                objWrpOrdCompPaso.blnIntercambio = true;
                objWrpOrdCompPaso.boolDistribuidoraActual = false;
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.blnDd = bExisteDD;
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.blnCancel = bExisteCheckOutCanceled;
                //Si se trata de un vin que ya esta registrado en DD
                objWrpOrdCompPaso.strSolName = strSolName;                

                String sIdExtCatModCet = sSerie + '' + sAnioModelo + '' + sModelo + '' + objInvPaso.TAM_ExteriorColorCodeF__c + '' + objInvPaso.TAM_InteriorColorCodeF__c;
                System.debug('EN agregaVinInter getModelos sIdExtCatModCet: ' + sIdExtCatModCet);
                
                objWrpOrdCompPaso.strIdCatModelos = mapIdExtCatCetMod.containsKey(sIdExtCatModCet) ?  mapIdExtCatCetMod.get(sIdExtCatModCet) : null;
                System.debug('EN agregaVinInter getModelos objWrpOrdCompPaso.strIdCatModelos: ' + objWrpOrdCompPaso.strIdCatModelos);
                
                //Agregalo a la lista
                if (!blnExiste && !blnExisteInvGDealer)
                   lObjWrpInvIntercam.add(objWrpOrdCompPaso);                    
                    
        }//Fin del for para TAM_InventarioVehiculosToyota__c
    	
    	//No exite en el inventario disponible para intercambio
    	if (!blnExiste && !blnExisteInvG && !blnExisteInvGDealer && (bExisteDD || bExisteCheckOutCanceled) || Test.isRunningTest()){
            
            String sIdExtCheckOut = objCheckOutCons.id != null ? objCheckOutCons.TAM_IdExterno__c : null;
            String[] lIdExterno = new List<String>();
            lIdExterno = sIdExtCheckOut != null ? sIdExtCheckOut.split('-') : new List<String>(); // a241Y00001VgU6gQAF-2020-HILUX-7494-040-200-57051-TOYOTA PRUEBA
            System.debug('EN agregaVinInter getModelos lIdExterno2: ' + lIdExterno + ' lIdExterno.size(): ' + lIdExterno.size() + ' lIdExterno: ' + lIdExterno);
                        
            //a241Y00001NaQroQAF-2021-PRIUS C-1280-1F7-12-0121Y000001J4rLQAS-0121Y000001J4rJQAS-JTDKDTB36M1142780  
            String strCodigoModelo = lIdExterno.size() > 6 ? (lIdExterno[3] + '' + lIdExterno[1]) : (VehiculoVCons.id != null ? VehiculoVCons.Producto__r.Name + '' + VehiculoVCons.Producto__r.Anio__c : '');
            String sMarca = 'Toyota';
            String sSeriePaso = mapIdExtProdSerie.containsKey(strCodigoModelo) ? mapIdExtProdSerie.get(strCodigoModelo) : null; 
            String sSerie = sSeriePaso == null ? (objCheckOutCons.id != null ? objCheckOutCons.TAM_Serie__c : (VehiculoVCons.id != null ? VehiculoVCons.SerieAD__c : '')) : sSeriePaso;             
            String sModelo = lIdExterno.size() > 6 ? lIdExterno[3] : (VehiculoVCons.id != null ? VehiculoVCons.Producto__r.Name : ''); 
            String sAnioModelo = lIdExterno.size() > 6 ? lIdExterno[1] : (VehiculoVCons.id != null ? VehiculoVCons.Producto__r.Anio__c : '');
            String sVersion = lIdExterno.size() > 6 ? objCheckOutCons.TAM_Version__c : (VehiculoVCons.id != null ? VehiculoVCons.Modelo_b__r.Version__c : '');
            String sCodigoColorExterior = lIdExterno.size() > 6 ? lIdExterno[4] : (VehiculoVCons.id != null ? VehiculoVCons.ColorExternoVehiculo__r.CodigoColor__c : ''); //objInvPaso.TAM_ExteriorColorCodeF__c + ' ' + objInvPaso.Exterior_Color_Description__c; //slDatosModelo[4] + ' ' + CatCentMod.DescripcionColorExterior__c;
            String sCodigoColorInterior = lIdExterno.size() > 6 ? lIdExterno[5] : (VehiculoVCons.id != null ? VehiculoVCons.ColorInternoVehiculo__r.CodigoColor__c : ''); //objInvPaso.TAM_InteriorColorCodeF__c + ' ' + objInvPaso.Interior_Color_Description__c; //slDatosModelo[5] + ' ' + CatCentMod.DescripcionColorInterior__c; 
            String sDescColorExterior = objCheckOutCons.id != null ? objCheckOutCons.TAM_Descripcion_Color_Exterior__c : (VehiculoVCons.id != null ? VehiculoVCons.ColorExternoVehiculo__r.Name : ''); //objInvPaso.TAM_ExteriorColorCodeF__c + ' ' + objInvPaso.Exterior_Color_Description__c; //slDatosModelo[4] + ' ' + CatCentMod.DescripcionColorExterior__c;
            String sDescColorInterior = objCheckOutCons.id != null ? objCheckOutCons.TAM_Descripcion_Color_Interior__c : (VehiculoVCons.id != null ? VehiculoVCons.ColorInternoVehiculo__r.Name : ''); //objInvPaso.TAM_InteriorColorCodeF__c + ' ' + objInvPaso.Interior_Color_Description__c; //slDatosModelo[5] + ' ' + CatCentMod.DescripcionColorInterior__c; 
            String sVin = lIdExterno.size() > 6 ? objCheckOutCons.TAM_VIN__c : (VehiculoVCons.id != null ? VehiculoVCons.Name : '');
            String sDealerCode = lIdExterno.size() > 6 ? objCheckOutCons.TAM_NombreDistribuidor__c : (VehiculoVCons.id != null ? VehiculoVCons.CodigoDistribuidor__c : '');
            System.debug('EN agregaVinInter getModelos strCodigoModelo2: ' + strCodigoModelo + ' sMarca: ' + sMarca + ' sSeriePaso: ' + sSeriePaso + ' sSerie: ' + sSerie + ' sModelo: ' + sModelo + ' sAnioModelo: ' + sAnioModelo + ' sVersion: ' + sVersion + ' sCodigoColorExterior: ' + sCodigoColorExterior + ' sCodigoColorInterior: ' + sCodigoColorInterior + ' sDescColorExterior: ' + sDescColorExterior + ' sDescColorInterior: ' + sDescColorInterior);
            
            //Crea el objeto del tipo TAM_OrdenDeCompraWrapperClass
           TAM_OrdenDeCompraWrapperClass objWrpOrdCompPaso = new TAM_OrdenDeCompraWrapperClass(
                        sMarca,
                        sSerie,
                        sModelo,
                        sAnioModelo,
                        (sVersion != NULL ? sVersion : ''), //sVersion,
                        sCodigoColorExterior, //slDatosModelo[4],
                        sCodigoColorInterior, //slDatosModelo[5],
                        sDescColorExterior, //Desc color ext
                        sDescColorInterior, //Desc color int
                        '0', //strCantidad
                        null, //strDescuentoDealer
                        String.valueOf(mapPriceBookEntry.get(strCodigoModelo)), //strPrecioSinIVA
                        null, //strSubtotal
                        sSerie + '-' + sModelo + '-' + sAnioModelo + '-' + sCodigoColorExterior + '-' + sCodigoColorInterior + '-' + (sVersion != NULL ? sVersion : ''), //strName
                        sSerie + '-' + (sVersion != NULL ? sVersion : '') + '-' + sModelo + '-' + sAnioModelo, //strNameCustom
                        sCodigoColorExterior + '-' + sDescColorExterior, //strColorExteriorCustom
                        sCodigoColorInterior + '-' + sDescColorInterior, //strColorInteriorCustom
                        false //boolDistribuidoraActual
           );
                
           //Inicializa el vin
           objWrpOrdCompPaso.strVin = sVin;
           objWrpOrdCompPaso.strNoDealer = sDealerCode;
           //Si se trata de intercambio
           objWrpOrdCompPaso.blnIntercambio = false;
           objWrpOrdCompPaso.boolDistribuidoraActual = false;
           //Si se trata de un vin que ya esta registrado en DD
           objWrpOrdCompPaso.blnDd = bExisteDD;
           //Si se trata de un vin que ya esta registrado en DD
           objWrpOrdCompPaso.blnCancel = bExisteCheckOutCanceled;
           //Si se trata de un vin que ya esta registrado en DD
           objWrpOrdCompPaso.strSolName = objCheckOutCons.id != null ? objCheckOutCons.TAM_SolicitudFlotillaPrograma__r.Name : '';                

           String sIdExtCatModCet = sSerie + '' + sAnioModelo + '' + sModelo + '' + sCodigoColorExterior + '' + sCodigoColorInterior;
           System.debug('EN agregaVinInter getModelos sIdExtCatModCet2: ' + sIdExtCatModCet);
                
           objWrpOrdCompPaso.strIdCatModelos = mapIdExtCatCetMod.containsKey(sIdExtCatModCet) ?  mapIdExtCatCetMod.get(sIdExtCatModCet) : null;
           System.debug('EN agregaVinInter getModelos objWrpOrdCompPaso.strIdCatModelos2: ' + objWrpOrdCompPaso.strIdCatModelos);
                
           //Agregalo a la lista
           lObjWrpInvIntercam.add(objWrpOrdCompPaso);
           
    	}//Fin si !blnExisteInvG && (bExisteDD || bExisteCheckOutCanceled)
    	
    	//Si ya existe en el inventario del Dealer
    	if (blnExisteInvGDealer || Test.isRunningTest()){
    	    TAM_OrdenDeCompraWrapperClass objWrpOrdCompPaso = new TAM_OrdenDeCompraWrapperClass();
    	    objWrpOrdCompPaso.blnExisteInvGDealer = true;
    	    objWrpOrdCompPaso.strVin = strNvoVinIntercambio;
    	    objWrpOrdCompPaso.strInvGDealerMsg = 'El Vin : ' + strNvoVinIntercambio + ' ya esta discponible en tu inventario, refresa la pagina para que los puedas seleccionar.';
            //Agregalo a la lista de lObjWrpInvIntercam
            lObjWrpInvIntercam.add(objWrpOrdCompPaso);    	    
    	}

        //Si ya existe en los vines para este pedido
        if (blnExiste || Test.isRunningTest()){
            TAM_OrdenDeCompraWrapperClass objWrpOrdCompPaso = new TAM_OrdenDeCompraWrapperClass();
            objWrpOrdCompPaso.blnExisteInvGDealer = true;
            objWrpOrdCompPaso.strVin = strNvoVinIntercambio;
            objWrpOrdCompPaso.strInvGDealerMsg = 'El Vin : ' + strNvoVinIntercambio + ' ya lo tienes seleccionado para tu pedido.';
            //Agregalo a la lista de lObjWrpInvIntercam
            lObjWrpInvIntercam.add(objWrpOrdCompPaso);
        }
        
        //Si no existe en ningun lado
        if (!blnExiste && !blnExisteInvG && !blnExisteInvGDealer && !bExisteDD && !bExisteCheckOutCanceled || Test.isRunningTest()){
            TAM_OrdenDeCompraWrapperClass objWrpOrdCompPaso = new TAM_OrdenDeCompraWrapperClass();
            objWrpOrdCompPaso.blnExisteInvGDealer = true;
            objWrpOrdCompPaso.strVin = strNvoVinIntercambio;
            objWrpOrdCompPaso.strInvGDealerMsg = 'El Vin : ' + strNvoVinIntercambio + ' No existe, por favor verificalo.';            
            //Agregalo a la lista de lObjWrpInvIntercam
            lObjWrpInvIntercam.add(objWrpOrdCompPaso);
        }
                
		System.debug('EN getDistribuidores lObjWrpInvIntercam: ' + lObjWrpInvIntercam);
        return lObjWrpInvIntercam;
    }   

    //Obtener distribuidores.
    @AuraEnabled
    public static List<TAM_OrdenDeCompraWrapperClass> removeRowHp(String recordId, List<TAM_OrdenDeCompraWrapperClass> lstVinInter, 
    	TAM_OrdenDeCompraWrapperClass objSelecPaso) {
    	System.debug('EN removeRowHp recordId: ' + recordId +' objSelecPaso: ' + objSelecPaso);
        System.debug('EN removeRowHp lstVinInter: ' + lstVinInter);
    	
		List<TAM_OrdenDeCompraWrapperClass> lObjWrpInvIntercam = new List<TAM_OrdenDeCompraWrapperClass>();
		List<TAM_OrdenDeCompraWrapperClass> lObjWrpInvIntercamFin = new List<TAM_OrdenDeCompraWrapperClass>();
		TAM_VinesFlotillaPrograma__c VinesFlotProdInter;
		//Inicializa la lista de lObjWrpInvIntercam 
		lObjWrpInvIntercam = lstVinInter;
				
		Set<String> setIdExtModAnio = new Set<String>();
		String sModel_Number = '';
		String sModel_Year = '';
		Boolean blnExiste = false;
		String sVinDel = '%';
		
		//Recorre la lista y ve si ya exste es vin: strNvoVinIntercambio
		for (TAM_OrdenDeCompraWrapperClass objPaso : lObjWrpInvIntercam){
			//Ve si strVin es igual  a strNvoVinIntercambio
			if (objPaso.strVin != objSelecPaso.strVin)
				lObjWrpInvIntercamFin.add(objPaso);
			if (objPaso.strVin == objSelecPaso.strVin)
				sVinDel += objSelecPaso.strVin + '%';
		}//Fin del for para lObjWrpInvIntercam
		System.debug('EN removeRowHp sVinDel: ' + sVinDel);
		
		//Consulta el vin en el objeto de 
	  	for (TAM_VinesFlotillaPrograma__c objTAMVinFlotProInter : [Select id
	  		//,TAM_DetalleSolicitudCompra_FLOTILLA__c 
	  		From TAM_VinesFlotillaPrograma__c
	  		Where TAM_IdExterno__c LIKE :sVinDel And TAM_SolicitudFlotillaPrograma__c =: recordId]){
	  		VinesFlotProdInter = objTAMVinFlotProInter;
	  	}
		System.debug('EN removeRowHp VinesFlotProdInter: ' + VinesFlotProdInter);
		
		if (VinesFlotProdInter != null)
			if (!Test.isRunningTest())
				delete VinesFlotProdInter;
		    	    	
		System.debug('EN removeRowHp lObjWrpInvIntercamFin: ' + lObjWrpInvIntercamFin);
        return lObjWrpInvIntercamFin;
    }   

    //Obtener distribuidores.
    @AuraEnabled
    public static List<TAM_OrdenDeCompraWrapperClass> removeRowPisoHP(String recordId, List<TAM_OrdenDeCompraWrapperClass> lstVinInter, 
    	TAM_OrdenDeCompraWrapperClass objSelecPaso) {
    	System.debug('EN removeRowPisoHP recordId: ' + recordId + ' objSelecPaso: ' + objSelecPaso);

		List<TAM_OrdenDeCompraWrapperClass> lObjWrpInvIntercam = new List<TAM_OrdenDeCompraWrapperClass>();
		List<TAM_OrdenDeCompraWrapperClass> lObjWrpInvIntercamFin = new List<TAM_OrdenDeCompraWrapperClass>();
		TAM_VinesFlotillaPrograma__c VinesFlotProdInter;
		//Inicializa la lista de lObjWrpInvIntercam 
		lObjWrpInvIntercam = lstVinInter;
				
		Set<String> setIdExtModAnio = new Set<String>();
		String sModel_Number = '';
		String sModel_Year = '';
		Boolean blnExiste = false;
		String sVinDel = '%';
		
		//Recorre la lista y ve si ya exste es vin: strNvoVinIntercambio
		for (TAM_OrdenDeCompraWrapperClass objPaso : lObjWrpInvIntercam){
			//Ve si strVin es igual  a strNvoVinIntercambio
			if (objPaso.strVin != objSelecPaso.strVin)
				lObjWrpInvIntercamFin.add(objPaso);
			if (objPaso.strVin == objSelecPaso.strVin)
				sVinDel += objSelecPaso.strVin + '%';
		}//Fin del for para lObjWrpInvIntercam
		System.debug('EN removeRowPisoHP sVinDel: ' + sVinDel);
		
		//Consulta el vin en el objeto de 
	  	for (TAM_VinesFlotillaPrograma__c objTAMVinFlotProInter : [Select id
	  		//,TAM_DetalleSolicitudCompra_FLOTILLA__c 
	  		From TAM_VinesFlotillaPrograma__c
	  		Where TAM_IdExterno__c LIKE :sVinDel And TAM_SolicitudFlotillaPrograma__c =: recordId]){
	  		VinesFlotProdInter = objTAMVinFlotProInter;
	  	}
		System.debug('EN removeRowPisoHP VinesFlotProdInter: ' + VinesFlotProdInter);
		if (VinesFlotProdInter != null)
			delete VinesFlotProdInter;
		    	    	
		System.debug('EN removeRowPisoHP lObjWrpInvIntercamFin: ' + lObjWrpInvIntercamFin);
        return lObjWrpInvIntercamFin;
    }   


    public static string getTipoRegSol(String sTipoRegSol, Boolean bSaveDatos) {
    	System.debug('EN getTipoRegSol sTipoRegSol: ' + sTipoRegSol);
    	
    	String sTipoRegSolPaso = '';
    	
    	if (bSaveDatos){
    	sTipoRegSolPaso = sTipoRegSol == sRectorTypePasoSolPrograma ? sRectorTypePasoPrograma :
    		(sTipoRegSol == sRectorTypePasoSolProgramaCerrada ? sRectorTypePasoPrograma :
    			( sTipoRegSol == sRectorTypePasoSolVentaCorporativa ? sRectorTypePasoGFlotilla : 
    		 		( sTipoRegSol == sRectorTypePasoSolVentaCorporativaCerrada ? sRectorTypePasoGFlotilla : sRectorTypePasoPrograma)
    		 	) 
    		);
    	}
		
		if (!bSaveDatos){	
    	sTipoRegSolPaso = sTipoRegSol == sRectorTypePasoSolPrograma ? sRectorTypePasoSolPrograma :
    		(sTipoRegSol == sRectorTypePasoSolProgramaCerrada ? sRectorTypePasoSolPrograma :
    			( sTipoRegSol == sRectorTypePasoSolVentaCorporativa ? sRectorTypePasoSolVentaCorporativa : 
    		 		( sTipoRegSol == sRectorTypePasoSolVentaCorporativaCerrada ? sRectorTypePasoSolVentaCorporativa : sRectorTypePasoSolPrograma)
    		 	) 
    		);
		}
		
		System.debug('EN getTipoRegSol sTipoRegSolPaso: ' + sTipoRegSolPaso);
        return sTipoRegSolPaso;
    }
	
}